 /**
 *                                                                             *
 * @file ErrorsListWidget.h                                                    *
 * Project name: HeKatE hqed                                                   *
 * $Id: ErrorsListWidget.h,v 1.15 2008-03-31 10:23:06 kinio Exp $               *
 * Author: Krzysztof Kaczor                                                    *
 * Date: 09.11.2007                                                            *
 *                                                                             *
 * Implementation by Krzysztof Kaczor <kinio4444@gmail.com>                    *
 *                                                                             *
 * Copyright (C) 2006-9 by the HeKatE Project                                  *
 *                                                                             *
 * HQEd has been develped within the HeKatE Project,                           *
 * see http://hekate.ia.agh.edu.pl                                             *
 *                                                                             *
 * This file is part of HQEd.                                                  *
 *                                                                             *
 * HQEd is free software: you can redistribute it and/or modify                *
 * it under the terms of the GNU General Public License as published by        *
 * the Free Software Foundation, either version 3 of the License, or           *
 * (at your option) any later version.                                         *
 *                                                                             *
 * HQEd is distributed in the hope that it will be useful,                     *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of              *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               *
 * GNU General Public License for more details.                                *
 *                                                                             *
 * You should have received a copy of the GNU General Public License           *
 * along with HQEd.  If not, see <http://www.gnu.org/licenses/>.               *
 *                                                                             *
 * Comment: Plik zwierajacy definicje klasy bedacej kontrolka, lista bledow    *
 * w komorkach                                                                 *
 *                                                                             *
 */

#ifndef ERRORSLISTWIDGETH
#define ERRORSLISTWIDGETH
// -----------------------------------------------------------------------------

class QWidget;
class QListWidget;

// -----------------------------------------------------------------------------

#define ERROR_TYPE 0
#define WARNING_TYPE 1
#define INFORMATION_TYPE 2
// -----------------------------------------------------------------------------

#include <QList>
#include <QListWidget>

#include "../../M/XTT/XTT_Cell.h"
// -----------------------------------------------------------------------------

class ErrorsListWidget : public QListWidget
{
    Q_OBJECT

private:

	QList<int> fTCs;				// Lista identyfikatorow "nadawcow" wiadmosci - 0-tabela i komorka, 1-polaczenia
	QList<int> fTablesIDs;			// Lista identyfikatorow tabel
	QList<int> fCellsIDs;			// Lista identyfikatorow komorek
	QList<XTT_Cell*> fCells;			// Lista wskaznikow do komorek
	QList<QString> fCellsErrors;		// Lista bledow
	
	QString icons[3];				// Sciezki dostepu do ikon
	QString msgTypes[3];			// Typy wiadomosci
	
public:
	
	/// Kostruktor domyslny
	ErrorsListWidget(QWidget * parent = 0);
	
	/// Metoda dodajaca element do obiektu
	void add(int, int, QString, int _msgType = 0, int _tc = 0);
	
	/// Metoda usuwajaca element
	bool deleteItem(int, int, int _tc = 0);
	
	/// Metoda usuwajaca wszystkie elementy
	void deleteAll(void);
	
public slots:

	/// Wywolywana w momencie zmiany zaznaczenia
	void onRowChange(int);
	
	/// Wywolywana w momencie klikniecia elementu
	void itemClick(QListWidgetItem*);
};
// -----------------------------------------------------------------------------

#endif
